/* Generated by wayland-scanner 1.19.0 */

#ifndef GAMMA_CONTROL_CLIENT_PROTOCOL_H
#define GAMMA_CONTROL_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_gamma_control The gamma_control protocol
 * @section page_ifaces_gamma_control Interfaces
 * - @subpage page_iface_gamma_control_manager - 
 * - @subpage page_iface_gamma_control - 
 * @section page_copyright_gamma_control Copyright
 * <pre>
 *
 * Copyright © 2015 Giulio camuffo
 *
 * Permission to use, copy, modify, distribute, and sell this
 * software and its documentation for any purpose is hereby granted
 * without fee, provided that the above copyright notice appear in
 * all copies and that both that copyright notice and this permission
 * notice appear in supporting documentation, and that the name of
 * the copyright holders not be used in advertising or publicity
 * pertaining to distribution of the software without specific,
 * written prior permission.  The copyright holders make no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied
 * warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
 * THIS SOFTWARE.
 * </pre>
 */
struct gamma_control;
struct gamma_control_manager;
struct wl_output;

#ifndef GAMMA_CONTROL_MANAGER_INTERFACE
#define GAMMA_CONTROL_MANAGER_INTERFACE
/**
 * @page page_iface_gamma_control_manager gamma_control_manager
 * @section page_iface_gamma_control_manager_api API
 * See @ref iface_gamma_control_manager.
 */
/**
 * @defgroup iface_gamma_control_manager The gamma_control_manager interface
 */
extern const struct wl_interface gamma_control_manager_interface;
#endif
#ifndef GAMMA_CONTROL_INTERFACE
#define GAMMA_CONTROL_INTERFACE
/**
 * @page page_iface_gamma_control gamma_control
 * @section page_iface_gamma_control_api API
 * See @ref iface_gamma_control.
 */
/**
 * @defgroup iface_gamma_control The gamma_control interface
 */
extern const struct wl_interface gamma_control_interface;
#endif

#define GAMMA_CONTROL_MANAGER_DESTROY 0
#define GAMMA_CONTROL_MANAGER_GET_GAMMA_CONTROL 1


/**
 * @ingroup iface_gamma_control_manager
 */
#define GAMMA_CONTROL_MANAGER_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_gamma_control_manager
 */
#define GAMMA_CONTROL_MANAGER_GET_GAMMA_CONTROL_SINCE_VERSION 1

/** @ingroup iface_gamma_control_manager */
static inline void
gamma_control_manager_set_user_data(struct gamma_control_manager *gamma_control_manager, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) gamma_control_manager, user_data);
}

/** @ingroup iface_gamma_control_manager */
static inline void *
gamma_control_manager_get_user_data(struct gamma_control_manager *gamma_control_manager)
{
	return wl_proxy_get_user_data((struct wl_proxy *) gamma_control_manager);
}

static inline uint32_t
gamma_control_manager_get_version(struct gamma_control_manager *gamma_control_manager)
{
	return wl_proxy_get_version((struct wl_proxy *) gamma_control_manager);
}

/**
 * @ingroup iface_gamma_control_manager
 */
static inline void
gamma_control_manager_destroy(struct gamma_control_manager *gamma_control_manager)
{
	wl_proxy_marshal((struct wl_proxy *) gamma_control_manager,
			 GAMMA_CONTROL_MANAGER_DESTROY);

	wl_proxy_destroy((struct wl_proxy *) gamma_control_manager);
}

/**
 * @ingroup iface_gamma_control_manager
 */
static inline struct gamma_control *
gamma_control_manager_get_gamma_control(struct gamma_control_manager *gamma_control_manager, struct wl_output *output)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_constructor((struct wl_proxy *) gamma_control_manager,
			 GAMMA_CONTROL_MANAGER_GET_GAMMA_CONTROL, &gamma_control_interface, NULL, output);

	return (struct gamma_control *) id;
}

#ifndef GAMMA_CONTROL_ERROR_ENUM
#define GAMMA_CONTROL_ERROR_ENUM
enum gamma_control_error {
	GAMMA_CONTROL_ERROR_INVALID_GAMMA = 0,
};
#endif /* GAMMA_CONTROL_ERROR_ENUM */

/**
 * @ingroup iface_gamma_control
 * @struct gamma_control_listener
 */
struct gamma_control_listener {
	/**
	 */
	void (*gamma_size)(void *data,
			   struct gamma_control *gamma_control,
			   uint32_t size);
};

/**
 * @ingroup iface_gamma_control
 */
static inline int
gamma_control_add_listener(struct gamma_control *gamma_control,
			   const struct gamma_control_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) gamma_control,
				     (void (**)(void)) listener, data);
}

#define GAMMA_CONTROL_DESTROY 0
#define GAMMA_CONTROL_SET_GAMMA 1
#define GAMMA_CONTROL_RESET_GAMMA 2

/**
 * @ingroup iface_gamma_control
 */
#define GAMMA_CONTROL_GAMMA_SIZE_SINCE_VERSION 1

/**
 * @ingroup iface_gamma_control
 */
#define GAMMA_CONTROL_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_gamma_control
 */
#define GAMMA_CONTROL_SET_GAMMA_SINCE_VERSION 1
/**
 * @ingroup iface_gamma_control
 */
#define GAMMA_CONTROL_RESET_GAMMA_SINCE_VERSION 1

/** @ingroup iface_gamma_control */
static inline void
gamma_control_set_user_data(struct gamma_control *gamma_control, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) gamma_control, user_data);
}

/** @ingroup iface_gamma_control */
static inline void *
gamma_control_get_user_data(struct gamma_control *gamma_control)
{
	return wl_proxy_get_user_data((struct wl_proxy *) gamma_control);
}

static inline uint32_t
gamma_control_get_version(struct gamma_control *gamma_control)
{
	return wl_proxy_get_version((struct wl_proxy *) gamma_control);
}

/**
 * @ingroup iface_gamma_control
 */
static inline void
gamma_control_destroy(struct gamma_control *gamma_control)
{
	wl_proxy_marshal((struct wl_proxy *) gamma_control,
			 GAMMA_CONTROL_DESTROY);

	wl_proxy_destroy((struct wl_proxy *) gamma_control);
}

/**
 * @ingroup iface_gamma_control
 */
static inline void
gamma_control_set_gamma(struct gamma_control *gamma_control, struct wl_array *red, struct wl_array *green, struct wl_array *blue)
{
	wl_proxy_marshal((struct wl_proxy *) gamma_control,
			 GAMMA_CONTROL_SET_GAMMA, red, green, blue);
}

/**
 * @ingroup iface_gamma_control
 */
static inline void
gamma_control_reset_gamma(struct gamma_control *gamma_control)
{
	wl_proxy_marshal((struct wl_proxy *) gamma_control,
			 GAMMA_CONTROL_RESET_GAMMA);
}

#ifdef  __cplusplus
}
#endif

#endif
